package edu.vub.nfc;

import android.app.Activity;
import android.nfc.NdefMessage;
import android.nfc.NfcAdapter;
import android.nfc.NfcEvent;
import android.nfc.Tag;
import android.nfc.NfcAdapter.CreateNdefMessageCallback;
import android.nfc.NfcAdapter.OnNdefPushCompleteCallback;
import android.os.Bundle;
import android.widget.Toast;
import edu.vub.AndroidNFC.R;
import edu.vub.nfc.beam.listener.BeamSuccessListener;
import edu.vub.nfc.thing.Thing;
import edu.vub.nfc.thing.listener.ThingBroadcastFailedListener;
import edu.vub.nfc.thing.listener.ThingBroadcastSuccessListener;

public class BeamWifiJoinerActivity extends AbstractWifiJoinerActivity implements CreateNdefMessageCallback, OnNdefPushCompleteCallback {


	private NdefMessage ndefMessageToBeam_;

	@Override
	protected int getContentView() {
		return R.layout.create;
	}

	@Override
	protected String getActivityTitle() {
		return "Share WiFi joiner";
	}

	@Override
	protected String getButtonText() {
		return "Share";
	}

	@Override
	protected void reactOnButtonClick(WifiConfig wc) {
		lock();
		if (ssidField_ != null && keyField_ != null) {
			wifiConfig_ = new WifiConfig(ssidField_.getText().toString(), keyField_.getText().toString());
			broadcast(wifiConfig_);
		} else {
			toast("You forgot to enter the SSID and key!");
		}
	}
	
	@Override
	public void onCreate(Bundle b) {
		super.onCreate(b);
		
        if (mNfcAdapter_ == null) {
            Toast.makeText(this, "NFC is not available", Toast.LENGTH_LONG).show();
            finish();
            return;
        }
		mNfcAdapter_.setNdefPushMessageCallback(this, this);
        mNfcAdapter_.setOnNdefPushCompleteCallback(this, this, new Activity[0]);
	}
	
	@Override
    public NdefMessage createNdefMessage(NfcEvent event) {
    	return ndefMessageToBeam_;
    }
    
	@Override
	public void onNdefPushComplete(NfcEvent event) {
		this.writeSucceeded(wifiConfig_);
	}

	private void broadcast(WifiConfig wifiConfig_) {
		new Thread(new Runnable() {

			@Override
			public void run() {
				
				
			}
			
		}).run();
	}

	@Override
	protected void performAction(NdefMessage msg, Tag tag) {
		// TODO Auto-generated method stub
	}

	@Override
	public void writeSucceeded(WifiConfig wc) {
		unlock();
		toast("WiFi joiner shared!");
	}

	@Override
	public void writeFailed(WifiConfig wc) {
		unlock();
		toast("Failed sharing WiFi joiner, try again.");
	}
}

