package edu.vub.nfc;

import edu.vub.AndroidNFC.R;
import edu.vub.nfc.thing.Thing;
import edu.vub.nfc.thing.listener.ThingBroadcastFailedListener;
import edu.vub.nfc.thing.listener.ThingBroadcastSuccessListener;

public class BeamWifiJoinerActivity extends AbstractWifiJoinerActivity {

	@Override
	public Class<? extends Thing> getThingType() {
		return WifiConfig.class;
	}

	@Override
	protected int getContentView() {
		return R.layout.create;
	}

	@Override
	protected String getActivityTitle() {
		return "Share WiFi joiner";
	}

	@Override
	protected String getButtonText() {
		return "Share";
	}

	@Override
	protected void reactOnButtonClick(WifiConfig wc) {
		ThingBroadcastSuccessListener successListener = new ThingBroadcastSuccessListener() {
			@Override
			public void signal(Thing thing) {
				unlock();
				toast("WiFi joiner shared!");
			}
			
		};
		ThingBroadcastFailedListener failedListener = new ThingBroadcastFailedListener() {	
			@Override
			public void signal(Thing thing) {
				unlock();
				toast("Failed sharing WiFi joiner, try again.");
			}
			
		};
		lock();
		if (ssidField_ != null && keyField_ != null) {
			wifiConfig_ = new WifiConfig(this, ssidField_.getText().toString(), keyField_.getText().toString());
			wifiConfig_.broadcast(successListener, failedListener, 5000);
		} else {
			toast("You forgot to enter the SSID and key!");
		}
	}
}

